﻿using System;
using System.Threading;
using System.Threading.Tasks; 

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            double[] array = new double[] { 10, 20, 30, 40, 50, 60, 70, 80, 90, 100 }; 

            Calculate(array); 

            Console.ReadKey(false);
        }

        #endregion

        #region 계산하기 - Calculate(array, startIndex, endIndex)

        /// <summary>
        /// 계산하기
        /// </summary>
        /// <param name="array">배열</param>
        /// <param name="startIndex">시작 인덱스</param>
        /// <param name="endIndex">종료 인덱스</param>
        private static void Calculate(double[] array, int startIndex, int endIndex)
        {
            for(int i = startIndex; i <= endIndex; i++)
            {
                Console.WriteLine(array[i]); 

                Thread.Sleep(300);
            }
        }

        #endregion
        #region 계산하기 - Calculate(array)

        /// <summary>
        /// 계산하기
        /// </summary>
        /// <param name="array">배열</param>
        private static void Calculate(double[] array)
        {
            Parallel.Invoke
            (
                () => Calculate(array, 0                   , array.Length / 2 - 1),
                () => Calculate(array, array.Length / 2 - 1, array.Length - 1    )
            );
        }

        #endregion
    }
}